-- Beispiel fuer strikte und
-- nicht strikte auswertung

-- mit "strictness flags"

data SFVect3D = SFVect3f !Float !Float !Float
newsfvect f g h = SFVect3f f g h

-- mit "call-by-value"

data SVect3D = SVect3f {x,y,z::Float}
newsvect x y z = ((SVect3f $! x) $! y) $! z

-- mit "lazy evaluation"

data LVect3D = LVect3f {u,v,w::Float}
newvect u v w = LVect3f u v w

-- "Show"-instanzen
-- fr definierte typen

instance Show SFVect3D
	where show v = "(...)"

instance Show SVect3D
	where show v = show (x v) ++ " " ++ show (y v)  ++ " " ++ show (z v)

instance Show LVect3D
	where show n = show (u n) ++ " " ++ show (v n)  ++ " " ++ show (w n)

-- "Eq"-instanzen

instance Eq SVect3D
	where (==) a b = ((x a)==(x b)&&(y a)==(y b)&&(z a)==(z b))

instance Eq LVect3D
	where (==) a b = ((u a)==(u b)&&(v a)==(v b)&&(w a)==(w b))

-- test methoden
tagvect v =(,) $! v

gettag = (snd)

-- evaluation order

nullvect = newvect 0 0 0
upvect = newvect 0 1 0
lvect = newvect (-1) 0 0
rvect = newvect 1 1 0
dirvect = newvect 0 0 1

isnullvect :: LVect3D->Bool
isnullvect v = (nullvect == v)

vectlen :: LVect3D->Float
vectlen p | (isnullvect p) = 0
					| otherwise = sqrt(((u p)*(u p))+((v p)*(v p))+((w p)*(w p)))

vectlens :: [LVect3D]->[Float]
vectlens [] = []
vectlens (hd:tl) = vectlen hd : vectlens tl

